public class IntBST implements OrderedIntList{

    // OVERVIEW: una OrderedIntList è una lista
    // modificabile di interi ordinata in modo crescente.
    // Tipico elemento: [x1, ..., xn], dove xi<xj se i<j
    private boolean vuota;
    private IntBST prima, dopo;
    private int val; 
    // la funzione di astrazione (ricorsiva!) 
    // a(c) = se c.vuota allora [], altrimenti
    // a(c.prima) + [c.val] + a(c.dopo) 

    // l’invariante di rappresentazione (ricorsivo!) 
    // I(c) = c.vuota oppure
    // (c.prima != null e c.dopo != null e 
    // I(c.prima) e I(c.dopo) e
    // (!c.prima.isEmpty() -> c.prima.max() < c.val) e
    // (!c.dopo.isEmpty() -> c.dopo.least() > c.val) )

    // costruttore senza parametri
    // NOTA: va realizzato nelle classi che implementano l'interfaccia
    public IntBST()
    // EFFECTS: inizializza this alla lista vuota
    { vuota = true; }

    // metodi 

}

